local enabled = true
local stunnedMode = false
local playerVolume

local function SetStunState(stunned)
	if stunned then
		if not stunnedMode and IsUnitInCombat("player") then
			stunnedMode = true
			SetFullscreenEffect(FULLSCREEN_EFFECT_UNIFORM_BLUR)
			local currentVolume = tonumber(GetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_AUDIO_VOLUME))
			if currentVolume > 0 then
				playerVolume = currentVolume
			end
			SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_AUDIO_VOLUME, 0)
		end
	else
		if stunnedMode then
			SetFullscreenEffect(FULLSCREEN_EFFECT_NONE)
			if playerVolume then
				SetSetting(SETTING_TYPE_AUDIO, AUDIO_SETTING_AUDIO_VOLUME, playerVolume)
				playerVolume = nil
			end
			stunnedMode = false
		end
	end
end

local function ToggleStunning()
	enabled = not enabled
	df("Stun impact effects are now %s.", enabled and "enabled" or "disabled")
	if not enabled then
		SetStunState(false)
	end
end

local function StunHandler(_, stunned)
	if enabled then
		SetStunState(stunned)
	end
end

local function AddonLoadHandler(_, addon)
	if addon and string.lower(addon) == "stunning" then
		EVENT_MANAGER:UnregisterForEvent("Stunning", EVENT_ADD_ON_LOADED)
		SLASH_COMMANDS["/stunning"] = ToggleStunning
	end
end

EVENT_MANAGER:RegisterForEvent("Stunning", EVENT_ADD_ON_LOADED, AddonLoadHandler)
EVENT_MANAGER:RegisterForEvent("Stunning", EVENT_PLAYER_STUNNED_STATE_CHANGED, StunHandler)